{***********************************************************************}
{           Pruebas de captura de mensajes del portapapeles             }
{                                                                       }
{               Copyright (C) 2003 por Neftal - Germn Estvez         }
{               E-mail: Neftali_GER@hotmail.com                         }
{***********************************************************************}
{ Este ejemplo puede ser distribuido libremente.                        }
{ ----------------------------------------------------------------------}
{ Version 1.01. Date last modified:  20/08/2003                         }
{ ----------------------------------------------------------------------}
unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TForm2 = class(TForm)
    Image1: TImage;
    Button2: TSpeedButton;
    Button3: TSpeedButton;
    Image2: TImage;
    Button1: TSpeedButton;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  cfIcon: Word;
  cfRTF: Word;

implementation

uses
  Clipbrd, FAbout;

{$R *.DFM}

procedure TForm2.Button2Click(Sender: TObject);
var
  memStream: TMemoryStream;
  Data: THandle;
  DataPtr: Pointer;
begin

  memStream := TMemoryStream.Create;
  try
    // Copiar el icono al Stream
    Self.Image1.Picture.Graphic.SaveToStream(memStream);
    // Reservar memoria
    Data := GlobalAlloc(GMEM_MOVEABLE, memStream.Size);
    try
      DataPtr := GlobalLock(Data);
      Move(memStream.Memory^, DataPtr^, memStream.Size);
      ClipBoard.Open;
      // Guardar el dato en el portapapeles
      Clipboard.SetAsHandle(cfIcon, Data);
      Clipboard.Close;
      // Desbloquear la memoria
      GlobalUnlock(Data);
    except
      GlobalFree(Data);
      raise;
    end;
  finally
    memStream.Free;
  end;

end;


procedure TForm2.Button3Click(Sender: TObject);
var
  Data: THandle;
  DataPtr: Pointer;
  MemStream: TMemoryStream;
begin
  Clipboard.Open;
  try
    // obtiene datos del Clipboard
    Data := Clipboard.GetAsHandle(cfIcon);
    try
      // No ha obtenido nada correcto?
      if Data = 0 then
        Exit;
      // Bloquea la memoria
      DataPtr := GlobalLock(Data);
      try
        // No ha podido bloquear memoria ?
        if DataPtr = nil then
          Exit;
        // Crea un Stream para almacenar los datos
        MemStream := TMemoryStream.Create;
        try
          // Escribe los datos en el Stream
          MemStream.WriteBuffer(DataPtr^, GlobalSize(Data));
          Memstream.Seek(0, 0);
          // Actualiza el icono del Form
          Self.Icon.LoadFromStream(Memstream);
          // Actualiza la imagen
          Image2.Picture.Graphic := Icon;

          MessageDlg('El control <Image> del formulario y el la propiedad <Icon> del formulario se '+#13+#10+'han actualizado correctamente.', mtInformation, [mbOK], 0);

        finally
          memStream.Free;
        end;
      finally
        // Desbloquear la memoria
        GlobalUnlock(Data);
      end;
    except
      // Liberarla
      GlobalFree(Data);
      raise;
    end;
  finally
    clipboard.Close;
  end;


end;




procedure TForm2.Button1Click(Sender: TObject);
var
  FormAbout: TFormAbout;
begin
  Application.CreateForm(TFormAbout, FormAbout);
  FormAbout.ShowModal;
end;

initialization
  cfIcon := RegisterClipboardFormat('Icon Data');

end.
